#include <stdlib.h>
#include <string.h>

#include <unistd.h>
#include <time.h>
#include "rtp_packet.hh"
#include "sys_time.hh"

#ifdef __sun__
#include "b.hh"
#endif



/************************************************************************
**                              RTP_HEADER                             **
************************************************************************/


RTP_Header::RTP_Header() 
: FlatMemory(12)
{
  header = (struct rtp_fix_header*) FlatMemory::Address();
}

RTP_Header::RTP_Header(FlatMemory& _mem,unsigned int _offset)
: FlatMemory(_mem,12,_offset)
{
  header = (struct rtp_fix_header*) FlatMemory::Address();
}

RTP_Header::~RTP_Header()
{
  //cout << "RTP_Packet: ~()\n";
  ;
}

/*
unsigned int RTP_Header::Read(void* address,unsigned int length,unsigned int offset)
{
  if(length + offset > sizeof(rtp_fix_header))
    length = sizeof(rtp_fix_header) - offset;
  
  bcopy((char*)header + offset,(char*)address,length);
  return length;
}

unsigned int RTP_Header::Write(void* address,unsigned int length,unsigned int offset)
{
  if(length > sizeof(rtp_fix_header) - offset)
    length = sizeof(rtp_fix_header) - offset;
  
  bcopy((char*)address,(char*)header + offset,length);
  return length;
}
*/


unsigned int RTP_Header::Size()
{
  return sizeof(rtp_fix_header);
}

unsigned int RTP_Header::DataSize()
{
  return sizeof(rtp_fix_header);
}

unsigned int RTP_Header::Header_size()
{
  return sizeof(rtp_fix_header);
}

int RTP_Header::GetVersion()
{
  return header->type;
}

int RTP_Header::GetPadding()
{
  return header->p;
}

int RTP_Header::GetExtension()
{
  return header->x;
}

int RTP_Header::GetCC()
{
  return header->cc;
}

int RTP_Header::GetMarker()
{
  return header->m;
}

int RTP_Header::GetPayloadType()
{
  return header->pt;
}

uint16 RTP_Header::GetSequence()
{
  return ntohuint16(header->seq);
}

uint32 RTP_Header::GetTimestamp()
{
  return ntohuint32(header->ts);
}

SSRC RTP_Header::GetSSRC()
{
  return SSRC(ntohuint32(header->ssrc));
}

/*
SSRC RTP_Header::GetCSRC(int i)
{
  if(header->cc == 0)
    return SSRC(0);
  if((i>=0)&&(i<=(header->cc - 1)))
    return SSRC(ntohuint32(header->csrc[i]));
  else
    return SSRC(0);
}
*/


void RTP_Header::SetVersion(int itype)
{
  header->type = itype;
}

void RTP_Header::SetPadding(int ipad)
{
  header->p = ipad;
}

void RTP_Header::SetExtension(int iext)
{
  header->x = iext;
}

void RTP_Header::SetCC(int icc)
{
  header->cc = icc;
}

void RTP_Header::SetMarker(int imark)
{
  header->m = imark;
}

void RTP_Header::SetPayloadType(int ipaytype)
{
  header->pt = ipaytype;
}

void RTP_Header::SetSequence(uint16 iseq)
{
  header->seq = htonuint16(iseq);
}

void RTP_Header::SetTimestamp(uint32 itime)
{
  header->ts = htonuint32(itime);
}

void RTP_Header::SetSSRC(SSRC issrc)
{
  header->ssrc = htonuint32((uint32)issrc);
}

/*
void RTP_Header::SetCSRC(int i,SSRC icsrc)
{
  if((i>=0)&&(i<=(header->cc - 1)))
    header->csrc[i] = htonuint32((uint32)icsrc);
}
*/


/************************************************************************
**                             RTP_PAYLOAD                             **
************************************************************************/

/*
RTP_PayLoad::RTP_PayLoad(void* paddr)
{
  pdata = paddr;
}

RTP_PayLoad::~RTP_PayLoad()
{
  ;
}
*/


/************************************************************************
**                             RTP_PACKET                              **
************************************************************************/

/*
RTP_Packet::RTP_Packet(Buffer* pInbuffer)
{
  pbuffer = pInbuffer;
  prtp_header = new RTP_Header(pInbuffer->BufferAddress());
  ppayload    = new RTP_PayLoad(pInbuffer->BufferAddress() + prtp_header->Header_size());
  ;
}

RTP_Packet::~RTP_Packet()
{
  delete prtp_header;
  delete ppayload;
}
*/


